/*
 * unixUtil.java
 *
 * Created on 3 de agosto de 2007, 18:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package kemit.util;

import java.io.*;
import java.util.*;
import kemit.ldap.objectos.UsuarioLDAP;

/**
 *
 * @author JL
 */
public class unixUtil {
    
    /** Creates a new instance of unixUtil */
    public unixUtil() {
    }
    
    static boolean debug=false;
    static private String strError;
    private static Exception excepcion;
    private static String err;
    private static String res;

    
    static public boolean ejecuta(String comando,String[] env,String dirw) {	
        boolean status=false;
        if (comando==null || comando.trim().equals("") ) {setStrError("No command specified");return status;}
        Vector comandos=new Vector();
        Process pro;
        File f=null;
        String nb="";
        if (dirw!=null) {
            try {f=new File(dirw); } 
            catch (Exception e) {
                setExcepcion(e);
                setStrError("Unexisting working dir");		
            }
        }		
        StringTokenizer st=new StringTokenizer(comando," ");
        while (st.hasMoreTokens()) {
            String coco=st.nextToken();
            comandos.add(coco);
        }

        String[] cmd=new String[comandos.size()];
        cmd=(String[]) comandos.toArray(cmd);
        StringBuffer sb=new StringBuffer(30000);
        StringBuffer se=new StringBuffer(300);
        try {
            pro=Runtime.getRuntime().exec(cmd,env,f);
            BufferedReader br=new BufferedReader(new InputStreamReader(pro.getInputStream()));
            BufferedReader brerror=new BufferedReader(new InputStreamReader(pro.getErrorStream()));
            String linea;
            while  ( (linea=br.readLine() ) != null ) sb.append(linea+"\n"); 
            while  ( (linea=brerror.readLine() ) != null )  se.append(linea+"\n"); 
            pro.waitFor();
            status=true;
        }
        catch (Exception e) {
            setExcepcion(e);
            String COM="";
            for (int i=0;i<cmd.length;i++) COM+=" "+cmd[i];
            setStrError("Error when executing \""+COM+"\"  ");		
            status=false;
        }
        setRes(sb.toString());
        setErr(se.toString());
        return status;
    }
    
    static public boolean ejecutaS(String comando,String[] env,String dirw) {	
        boolean status=false;
        if (comando==null || comando.trim().equals("") ) {setStrError("No command");return status;}
        Process pro;
        File f=null;
        String nb="";
        if (dirw!=null) {
            try {f=new File(dirw); } catch (Exception e) {setExcepcion(e);setStrError("Unexisting working dir");		}
        }		
        StringBuffer sb=new StringBuffer(30000);
        StringBuffer se=new StringBuffer(300);
        try {
            pro=Runtime.getRuntime().exec(comando,env,f);
            BufferedReader br=new BufferedReader(new InputStreamReader(pro.getInputStream()));
            BufferedReader brerror=new BufferedReader(new InputStreamReader(pro.getErrorStream()));
            String linea;
            while  ( (linea=br.readLine() ) != null ) sb.append(linea+"\n"); 
            while  ( (linea=brerror.readLine() ) != null )  se.append(linea+"\n"); 
            pro.waitFor();
            status=true;
        }
        catch (Exception e) {
            setExcepcion(e);
            setStrError("Error executing \""+comando+"\"  ");		
            status=false;
        }
        setRes(sb.toString());
        setErr(se.toString());
        return status;
    }

    
    
    public Vector getUnixUsers() {
        Vector ul=new Vector();
        String[] linus=ficheroA("/etc/passwd");
        if (linus==null) return ul;
        for (int i=0;i<linus.length;i++) {
            unixUser usu=new unixUser(linus[i]);
            if (usu.getUid()!=null) ul.add(usu);
        }
        return ul;
    }
    
    public Vector getUnixGroups() {
        Vector ul=new Vector();
        String[] linus=ficheroA("/etc/group");
        if (linus==null) return ul;
        for (int i=0;i<linus.length;i++) {
            unixGroup grp=new unixGroup(linus[i]);
            if (grp.getCn()!=null) ul.add(grp);
        }
        return ul;
    }
        
    
    
    public static String fichero(String nombre) {
        StringBuffer sb=new StringBuffer();
        try {    
            BufferedReader in =new BufferedReader(new FileReader(nombre));    
            String str;
            while ((str = in.readLine()) != null) {sb.append(str);}
            in.close();
            return sb.toString();
        } catch (Exception ex) {
            setExcepcion(ex);
        }      
        return "";
    }

    public static String[] ficheroA(String nombre) {
        
        Vector lineas=new Vector();
        try {    
            BufferedReader in =new BufferedReader(new FileReader(nombre));    
            String str;
            while ((str = in.readLine()) != null) {lineas.add(str);}
            in.close();
            String[] lin=new String[lineas.size()];
            for (int i=0;i<lineas.size();i++) lin[i]=(String)lineas.get(i);
            return lin;
        } catch (Exception ex) {
            setExcepcion(ex);
        }      
        return null;
    }
    
    
    
    public static boolean fichero_tiene(String nombre,String linea) {
        
        try {    
            BufferedReader in =new BufferedReader(new FileReader(nombre));    
            String str;
            while ((str = in.readLine()) != null) {
                if (str.indexOf(linea)!=-1) return true;
            }
            in.close();            
        } catch (Exception ex) {
            setExcepcion(ex);
        }      
        return false;
    }
    
    public static boolean fichero_anyade(String nombre,String linea) {        
        try {    
            BufferedWriter out = new BufferedWriter(new FileWriter(nombre, true));
            out.write(linea);
            out.close();
            return true;
        } catch (Exception ex) {
            setExcepcion(ex);
        }      
        return false;
    }
    
    public static boolean fichero_copia(String origen,String fin) {        
        try {    
            BufferedReader in =new BufferedReader(new FileReader(origen));    
            BufferedWriter out = new BufferedWriter(new FileWriter(fin, false));
            String str;
            while ((str = in.readLine()) != null) {
                out.write(str+"\n");
            }
            in.close();                                                
            out.close();
            return true;
        } catch (Exception ex) {
            setExcepcion(ex);
        }      
        return false;
    }
    
    public static boolean fichero_cambia(String origen,String fin,String linorig,String[] linnew,int num) {        
        try {    
            BufferedReader in =new BufferedReader(new FileReader(origen));    
            BufferedWriter out = new BufferedWriter(new FileWriter(fin, false));
            String str;
            while ((str = in.readLine()) != null) {  
                //System.out.println(str);
                if (str.indexOf(linorig)>=0) {
                    for (int i=0;i<linnew.length;i++) out.write(linnew[i]+"\n");                    
                    for (int j=0;j<num;j++) str = in.readLine();
                }
                else out.write(str+"\n");
            }
            in.close();                                                
            out.close();
            return true;
        } catch (Exception ex) {
            setExcepcion(ex);
        }      
        return false;
    }
    
    public static boolean fichero_pon(String origen,String fin,String linorig,String[] linnew) {        
        try {    
            BufferedReader in =new BufferedReader(new FileReader(origen));    
            BufferedWriter out = new BufferedWriter(new FileWriter(fin, false));
            String str;
            while ((str = in.readLine()) != null) {  
                //System.out.println(str);
                if (str.indexOf(linorig)>=0) {
                    for (int i=0;i<linnew.length;i++) out.write(linnew[i]+"\n");                    
                    //for (int j=0;j<num;j++) str = in.readLine();
                }
                else out.write(str+"\n");
            }
            in.close();                                                
            out.close();
            return true;
        } catch (Exception ex) {
            setExcepcion(ex);
        }      
        return false;
    }
        
    public static boolean fichero_pon(String origen,String linorig,String linnew) {        
        try {    
            BufferedReader in =new BufferedReader(new FileReader(origen));    
            BufferedWriter out = new BufferedWriter(new FileWriter(origen+"TMP", false));
            String str;            
            while ((str = in.readLine()) != null) {  
                out.write(str+"\n");
                if (str.indexOf(linorig)>=0) out.write(linnew+"\n");                                                    
            }
            in.close();                                                
            out.close();
            File o=new File(origen);
            o.delete();
            File d=new File(origen+"TMP");
            d.renameTo(o);
            return true;
        } catch (Exception ex) {
            setExcepcion(ex);
        }      
        return false;
    }

    
    
    // Clases Utilitarias
    
    public class unixUser {
        private String uid;
        private String uidNumber;
        private String gidNumber;
        
        unixUser(String s) {
            StringTokenizer st=new StringTokenizer(s,":");
            
            if (st.countTokens()<3) {
                uid=null;                
                return ;
            }
            
            uid=st.nextToken();
            st.nextToken();
            uidNumber=st.nextToken();                        
        }

        public String getUid() {
            return uid;
        }

        public String getUidNumber() {
            return uidNumber;
        }

        public String getGidNumber() {
            return gidNumber;
        }
        
        
        
    }
    
    
    public class unixGroup {
        private boolean selected=false;
        private String cn;
        private String gidNumber;
        private String simbolo;
        private Vector usuarios=new Vector();
        
        unixGroup (String s) {
            StringTokenizer st=new StringTokenizer(s,":");

            if (st.countTokens()<3) {
                cn=null;                
                return ;
            }
            
            cn=st.nextToken();
            simbolo=st.nextToken();
            gidNumber=st.nextToken(); 
            
            
            String usu=null;
            if (st.hasMoreTokens()) usu=st.nextToken();
            if (usu!=null && !usu.equals(""))  {
                 StringTokenizer ust=new StringTokenizer(usu,",");
                 while (ust.hasMoreTokens())    {
                     usuarios.add(ust.nextToken());
                 }              
            }                       
            
        }
        
        
        public void ponUser(String u) {
            if (!usuarios.contains(u)) usuarios.add(u);
        }
        
        public Vector getUsuarios() {
            return usuarios;
        }
        
        public void setUsuarios(Vector v) {
            usuarios=v;
        }

        public String getCn() {
            return cn;
        }

        public String getGidNumber() {
            return gidNumber;
        }
        
       public String linea()   {
           String lin=getCn()+":"+getSimbolo()+":"+getGidNumber()+":";
           
           for (int i=0;i<getUsuarios().size();i++) {
               if (i==0) lin=lin+getUsuarios().get(i);
               else lin=lin+","+getUsuarios().get(i);
           }                      
           return lin;           
       }
       
       
       
       public String toString() {
            return "cn="+getCn()+",gid="+getGidNumber();
        }        

        public String getSimbolo() {
            return simbolo;
        }

        public void setSimbolo(String simbolo) {
            this.simbolo = simbolo;
        }

        public void quitaUser(UsuarioLDAP u) {
             if (usuarios.contains(u.getUid())) usuarios.remove(u.getUid());
        }

        public boolean isSelected() {
            return selected;
        }

        public void setSelected(boolean selected) {
            this.selected = selected;
        }
        
    }
    
    
    
    
    
    
    // Getters y Setters
    
    
    
    public String getStrError() {
        return strError;
    }

    public static void setStrError(String strError2) {
        strError = strError2;
    }

    public Exception getExcepcion() {
        return excepcion;
    }

    public static void setExcepcion(Exception excepcion2) {
        excepcion = excepcion2;
    }

    public static String getErr() {
        return err;
    }

    public static void setErr(String err2) {
        err = err2;
    }

    public static String getRes() {
        return res;
    }

    public static void setRes(String res2) {
        res = res2;
    }
    
}
