/*
 * cambiClau.java
 *
 * Created on 8 de agosto de 2007, 21:27
 */

package kemit;

import java.awt.*;
import java.net.URL;
import java.util.GregorianCalendar;
import java.util.Hashtable;
import java.util.ResourceBundle;
import javax.naming.*;
import javax.naming.directory.*;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import kemit.crypto.crypUtil;
import kemit.crypto.jcrypt;
import kemit.crypto.sambaPasswords;
import kemit.ssl.KemitSSLSocketFactory;
import kemit.util.SplashWindow;

/**
 *
 * @author  JL
 */
public class cambiClau extends javax.swing.JFrame {
    
    static cambiClau yo;
    
    Dimension screenSize;

    private String ATT,OLDPWD_NULL,SERVIDOR_NULL,NEWPWD_NULL,RETPWD_NULL,NO_COINCIDEN,UID_NULL;
    private String OK_CAMBIO,MAL_CAMBIO;
    
    private String SI_ADELANTE,NI_HABLAR,ESTA_A_PUNTO_DE_APLICAR_EN_SERVER,PREGUNTA;

    private boolean debug=true;

    private java.lang.String MAL_PWD, SERVIDOR_NO_DISPONIBLE;
    
    /** Creates new form cambiClau */
    public cambiClau() {
        initMsg();
        initComponents();
        setFocusTraversalPolicy(new focusCambio());
        initSecundarios();
    }
    void initMsg() {
        ATT=ResourceBundle.getBundle("textosClau").getString("ATT");
        OLDPWD_NULL=ResourceBundle.getBundle("textosClau").getString("OLDPWD_NULL");
        SERVIDOR_NULL=ResourceBundle.getBundle("textosClau").getString("SERVIDOR_NULL");
        NEWPWD_NULL=ResourceBundle.getBundle("textosClau").getString("NEWPWD_NULL");
        RETPWD_NULL=ResourceBundle.getBundle("textosClau").getString("RETPWD_NULL");
        NO_COINCIDEN=ResourceBundle.getBundle("textosClau").getString("NO_COINCIDEN");
        UID_NULL=ResourceBundle.getBundle("textosClau").getString("UID_NULL");
        OK_CAMBIO=ResourceBundle.getBundle("textosClau").getString("OK_CAMBIO");
        MAL_PWD=ResourceBundle.getBundle("textosClau").getString("MAL_PWD");
        SERVIDOR_NO_DISPONIBLE=ResourceBundle.getBundle("textosClau").getString("SERVIDOR_NO_DISPONIBLE");
        
        SI_ADELANTE=ResourceBundle.getBundle("textosClau").getString("SI_ADELANTE");
        NI_HABLAR=ResourceBundle.getBundle("textosClau").getString("NI_HABLAR");
        PREGUNTA=ResourceBundle.getBundle("textosClau").getString("PREGUNTA");
        ESTA_A_PUNTO_DE_APLICAR_EN_SERVER=ResourceBundle.getBundle("textosClau").getString("ESTA_A_PUNTO_DE_APLICAR_EN_SERVER");
        
    }
    
    void initSecundarios() {        
        screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        URL imageURL = cambiClau.class.getResource("/imagenes/ico_linkat.gif");        
        this.setIconImage(Toolkit.getDefaultToolkit().createImage(imageURL));                        
    }

    public void setVisible(boolean b) {
        if (b) {
            Dimension d=yo.getSize();
            //Dimension d=new Dimension(800,600);
            int w=(int) (screenSize.width-d.getWidth())/2;
            int h=(int) (screenSize.height-d.getHeight())/2;
            yo.setLocation(w,h);               
                        
        }
        super.setVisible(b);
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        txtUID = new javax.swing.JTextField();
        lUID = new javax.swing.JLabel();
        txtOLDPWD = new javax.swing.JPasswordField();
        txtNEWPWD = new javax.swing.JPasswordField();
        txtURL = new javax.swing.JTextField();
        loldpwd = new javax.swing.JLabel();
        lURL = new javax.swing.JLabel();
        lNEWPWD = new javax.swing.JLabel();
        pBotones = new javax.swing.JPanel();
        bCambiar = new javax.swing.JButton();
        bSalir = new javax.swing.JButton();
        lRETIPE = new javax.swing.JLabel();
        txtRETIPE = new javax.swing.JPasswordField();
        jLabel1 = new javax.swing.JLabel();
        listaAlgoritmos = new javax.swing.JComboBox();
        chSSL = new javax.swing.JCheckBox();
        jLabel2 = new javax.swing.JLabel();
        txtDominio = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("textosClau"); // NOI18N
        setTitle(bundle.getString("TIT_CAMBI_CLAU")); // NOI18N
        setResizable(false);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        txtUID.setColumns(15);
        txtUID.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtUIDActionPerformed(evt);
            }
        });
        txtUID.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtUIDFocusGained(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 0);
        getContentPane().add(txtUID, gridBagConstraints);

        lUID.setText(bundle.getString("UID")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 4);
        getContentPane().add(lUID, gridBagConstraints);

        txtOLDPWD.setColumns(20);
        txtOLDPWD.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtOLDPWDActionPerformed(evt);
            }
        });
        txtOLDPWD.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtOLDPWDFocusGained(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 0);
        getContentPane().add(txtOLDPWD, gridBagConstraints);

        txtNEWPWD.setColumns(20);
        txtNEWPWD.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtNEWPWDActionPerformed(evt);
            }
        });
        txtNEWPWD.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtNEWPWDFocusGained(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(12, 0, 2, 0);
        getContentPane().add(txtNEWPWD, gridBagConstraints);

        txtURL.setColumns(20);
        txtURL.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtURLActionPerformed(evt);
            }
        });
        txtURL.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtURLFocusGained(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(7, 0, 2, 10);
        getContentPane().add(txtURL, gridBagConstraints);

        loldpwd.setText(bundle.getString("OLD")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 4);
        getContentPane().add(loldpwd, gridBagConstraints);

        lURL.setText(bundle.getString("IP")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(7, 10, 2, 4);
        getContentPane().add(lURL, gridBagConstraints);

        lNEWPWD.setText(bundle.getString("NUEVA")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(12, 0, 2, 4);
        getContentPane().add(lNEWPWD, gridBagConstraints);

        bCambiar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/server_lock24.png"))); // NOI18N
        bCambiar.setText(bundle.getString("CAMBIAR")); // NOI18N
        bCambiar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bCambiarActionPerformed(evt);
            }
        });
        pBotones.add(bCambiar);

        bSalir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/exit.png"))); // NOI18N
        bSalir.setText(bundle.getString("SALIR")); // NOI18N
        bSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSalirActionPerformed(evt);
            }
        });
        pBotones.add(bSalir);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(6, 10, 5, 10);
        getContentPane().add(pBotones, gridBagConstraints);

        lRETIPE.setText(bundle.getString("RETIPE")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 4);
        getContentPane().add(lRETIPE, gridBagConstraints);

        txtRETIPE.setColumns(20);
        txtRETIPE.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtRETIPEActionPerformed(evt);
            }
        });
        txtRETIPE.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtRETIPEFocusGained(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 0);
        getContentPane().add(txtRETIPE, gridBagConstraints);

        jLabel1.setText(bundle.getString("ALGORITMO")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 4);
        getContentPane().add(jLabel1, gridBagConstraints);

        listaAlgoritmos.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "LINUX", "PLAIN", "SHA", "MD5", "SSHA", "SMD5" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 0);
        getContentPane().add(listaAlgoritmos, gridBagConstraints);

        chSSL.setSelected(false);
        chSSL.setText(bundle.getString("USE_SSL")); // NOI18N
        chSSL.setMargin(new java.awt.Insets(0, 0, 0, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        getContentPane().add(chSSL, gridBagConstraints);

        jLabel2.setText(bundle.getString("DOMINIO")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 4);
        getContentPane().add(jLabel2, gridBagConstraints);

        txtDominio.setColumns(20);
        txtDominio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtDominioActionPerformed(evt);
            }
        });
        txtDominio.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtDominioFocusGained(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 0);
        getContentPane().add(txtDominio, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void txtRETIPEFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtRETIPEFocusGained
        ((JPasswordField)evt.getSource()).setSelectionStart(0);
        ((JPasswordField)evt.getSource()).setSelectionEnd(((JPasswordField)evt.getSource()).getPassword().length);
    }//GEN-LAST:event_txtRETIPEFocusGained

    private void txtNEWPWDFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtNEWPWDFocusGained
        ((JPasswordField)evt.getSource()).setSelectionStart(0);
        ((JPasswordField)evt.getSource()).setSelectionEnd(((JPasswordField)evt.getSource()).getPassword().length);
    }//GEN-LAST:event_txtNEWPWDFocusGained

    private void txtOLDPWDFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtOLDPWDFocusGained
        ((JPasswordField)evt.getSource()).setSelectionStart(0);
        ((JPasswordField)evt.getSource()).setSelectionEnd(((JPasswordField)evt.getSource()).getPassword().length);
    }//GEN-LAST:event_txtOLDPWDFocusGained

    private void txtUIDFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtUIDFocusGained
        ((JTextField)evt.getSource()).setSelectionStart(0);
        ((JTextField)evt.getSource()).setSelectionEnd(((JTextField)evt.getSource()).getText().length());
    }//GEN-LAST:event_txtUIDFocusGained

    private void txtURLFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtURLFocusGained
        ((JTextField)evt.getSource()).setSelectionStart(0);
        ((JTextField)evt.getSource()).setSelectionEnd(((JTextField)evt.getSource()).getText().length());
    }//GEN-LAST:event_txtURLFocusGained

    private void txtRETIPEActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtRETIPEActionPerformed
        ((JPasswordField)evt.getSource()).transferFocus();
    }//GEN-LAST:event_txtRETIPEActionPerformed

    private void txtNEWPWDActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtNEWPWDActionPerformed
        ((JPasswordField)evt.getSource()).transferFocus();
    }//GEN-LAST:event_txtNEWPWDActionPerformed

    private void txtOLDPWDActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtOLDPWDActionPerformed
        ((JPasswordField)evt.getSource()).transferFocus();
    }//GEN-LAST:event_txtOLDPWDActionPerformed

    private void txtUIDActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtUIDActionPerformed
       ((JTextField)evt.getSource()).transferFocus();
    }//GEN-LAST:event_txtUIDActionPerformed

    private void txtURLActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtURLActionPerformed
        ((JTextField)evt.getSource()).transferFocus();
    }//GEN-LAST:event_txtURLActionPerformed

    private void bCambiarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bCambiarActionPerformed
        
        
        
        if (txtOLDPWD.getPassword().toString().trim().equals("")) {
            JOptionPane.showMessageDialog(this,OLDPWD_NULL,ATT,JOptionPane.ERROR_MESSAGE);
            txtOLDPWD.requestFocus();
            return;
        }
        if (txtURL.getText().trim().equals("")) {
            JOptionPane.showMessageDialog(this,SERVIDOR_NULL,ATT,JOptionPane.ERROR_MESSAGE);
            txtURL.requestFocus();
            return;
        }
        if (new String(txtNEWPWD.getPassword()).trim().equals("")) {
            JOptionPane.showMessageDialog(this,NEWPWD_NULL,ATT,JOptionPane.ERROR_MESSAGE);
            txtNEWPWD.requestFocus();
            return;
        }
        if (new String(txtRETIPE.getPassword()).trim().equals("")) {
            JOptionPane.showMessageDialog(this,RETPWD_NULL,ATT,JOptionPane.ERROR_MESSAGE);
            txtRETIPE.requestFocus();
            return;
        }
        if (!(new String(txtNEWPWD.getPassword())).equals(new String(txtRETIPE.getPassword()))) {
            JOptionPane.showMessageDialog(this,NO_COINCIDEN,ATT,JOptionPane.ERROR_MESSAGE);            
            txtNEWPWD.requestFocus();
            return;
        }
        if (txtUID.getText().trim().equals("")) {
            JOptionPane.showMessageDialog(this,UID_NULL,ATT,JOptionPane.ERROR_MESSAGE);
            txtUID.requestFocus();
            return;
        }
        Object[] options = {SI_ADELANTE,NI_HABLAR};
        int n = JOptionPane.showOptionDialog(this,ESTA_A_PUNTO_DE_APLICAR_EN_SERVER,PREGUNTA,JOptionPane.YES_NO_OPTION,
                    JOptionPane.QUESTION_MESSAGE,null,options,options[1]); 
        
        if (n==1) return;

        
        Session sesion=new Session(txtUID.getText(),new String(txtOLDPWD.getPassword()),txtURL.getText(),txtDominio.getText(),chSSL.isSelected());

        if (sesion.getEx()!=null) {
            if (sesion.getEx() instanceof javax.naming.CommunicationException) {
                JOptionPane.showMessageDialog(this,SERVIDOR_NO_DISPONIBLE,ATT,JOptionPane.ERROR_MESSAGE);
                System.out.println("servidor");
            } 
            else if (sesion.getEx() instanceof javax.naming.AuthenticationException) {
                JOptionPane.showMessageDialog(this,MAL_PWD,ATT,JOptionPane.ERROR_MESSAGE);                
            }
            if (debug) sesion.getEx().printStackTrace();
            return;
        }

        try {        
            String algoritmo=(String)listaAlgoritmos.getSelectedItem();        
            String pwd=new String(txtNEWPWD.getPassword());

            GregorianCalendar gc=new GregorianCalendar();
            long segundos=gc.getTimeInMillis()/1000;               
            
            ModificationItem[] mods = new ModificationItem[4];                
            Attribute mod0 = new BasicAttribute("userPassword",encripta(pwd,algoritmo));
            Attribute mod1 = new BasicAttribute("sambaLMPassword",sambaPasswords.SambaLMPassword(pwd));
            Attribute mod2 = new BasicAttribute("sambaNTPassword",sambaPasswords.SambaNTPassword(pwd));
            Attribute mod3 = new BasicAttribute("sambaPWDLastSet",""+segundos );

            mods[0] = new ModificationItem(DirContext.REPLACE_ATTRIBUTE,mod0);
            mods[1] = new ModificationItem(DirContext.REPLACE_ATTRIBUTE,mod1);
            mods[2] = new ModificationItem(DirContext.REPLACE_ATTRIBUTE,mod2);
            mods[3] = new ModificationItem(DirContext.REPLACE_ATTRIBUTE,mod3);


                sesion.getCtx().modifyAttributes("uid="+txtUID.getText()+",ou=people", mods);              
            sesion.getCtx().close();
            JOptionPane.showMessageDialog(this,OK_CAMBIO,ATT,JOptionPane.INFORMATION_MESSAGE);            
        } catch (Exception ex) {
            if (debug) ex.printStackTrace();  
            JOptionPane.showMessageDialog(this,"Mal",ATT,JOptionPane.INFORMATION_MESSAGE);
        }                                       
                    

    }//GEN-LAST:event_bCambiarActionPerformed

    
    String encripta(String s,String modo){                        
        if (modo.toUpperCase().equals("PLAIN")) return s;
        else if (modo.toUpperCase().equals("LINUX")) return "{crypt}"+jcrypt.crypt(s);
        else if (modo.toUpperCase().equals("SHA")) return new String(crypUtil.mdDecode(s, 4, null));
        else if (modo.toUpperCase().equals("MD5")) return new String(crypUtil.mdDecode(s, 2, null));
        else if (modo.toUpperCase().equals("SSHA")) return new String(crypUtil.mdDecode(s, 5, saltando()));
        else if (modo.toUpperCase().equals("SMD5")) return new String(crypUtil.mdDecode(s, 3, saltando()));
        else return s;
    }
    
    byte[] saltando() {        
        final String SALTCHARS = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
        
        StringBuffer salt = new StringBuffer();
        java.util.Random rnd = new java.util.Random();        
        while (salt.length() < 8) {
            int index = (int) (rnd.nextFloat() * SALTCHARS.length());
            salt.append(SALTCHARS.substring(index, index+1));
        }
        return salt.toString().getBytes();
    }
    
    
    
    private void bSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSalirActionPerformed
        
        System.exit(0);
    }//GEN-LAST:event_bSalirActionPerformed

    private void txtDominioFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtDominioFocusGained
        ((JTextField)evt.getSource()).setSelectionStart(0);
        ((JTextField)evt.getSource()).setSelectionEnd(((JTextField)evt.getSource()).getText().length());
    }//GEN-LAST:event_txtDominioFocusGained

    private void txtDominioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtDominioActionPerformed
        ((JTextField)evt.getSource()).transferFocus();
    }//GEN-LAST:event_txtDominioActionPerformed
 
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        Frame splashFrame = null;
        URL imageURL = cambiClau.class.getResource("/imagenes/gus_def_01.png");
        if (imageURL != null) {
            splashFrame = SplashWindow.splash(Toolkit.getDefaultToolkit().createImage(imageURL));
        } else {
            System.err.println("Splash image not found");
     
        }
        final Frame sp=splashFrame;

        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                yo=new cambiClau();
                try {
                    Thread.sleep(3000);
                    yo.setVisible(true);
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }
                if (sp != null) sp.dispose();
            }
        });
        
    }

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bCambiar;
    private javax.swing.JButton bSalir;
    private javax.swing.JCheckBox chSSL;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel lNEWPWD;
    private javax.swing.JLabel lRETIPE;
    private javax.swing.JLabel lUID;
    private javax.swing.JLabel lURL;
    private javax.swing.JComboBox listaAlgoritmos;
    private javax.swing.JLabel loldpwd;
    private javax.swing.JPanel pBotones;
    private javax.swing.JTextField txtDominio;
    private javax.swing.JPasswordField txtNEWPWD;
    private javax.swing.JPasswordField txtOLDPWD;
    private javax.swing.JPasswordField txtRETIPE;
    private javax.swing.JTextField txtUID;
    private javax.swing.JTextField txtURL;
    // End of variables declaration//GEN-END:variables
    
    public class Session {
        
        private DirContext ctx; 
        private Hashtable env;
        private String pwd;
        private Exception ex;
        
        
        public boolean isServerAlive(String user,String pwd,String server,String dominio) {
            env = new Hashtable();            
            env.put(Context.INITIAL_CONTEXT_FACTORY,"com.sun.jndi.ldap.LdapCtxFactory");     
            //TODO cambiar lo de intracentre
            env.put(Context.PROVIDER_URL, "ldap://"+server+":389/dc="+dominio);
            env.put("com.sun.jndi.ldap.connect.timeout", "500");
            env.put(Context.SECURITY_AUTHENTICATION, "simple");
                      
            //TODO cambiar lo de intracentre
            env.put(Context.SECURITY_PRINCIPAL, "uid="+user+",ou=people,dc="+dominio);            
            env.put(Context.SECURITY_CREDENTIALS, pwd);
            env.put("java.naming.ldap.version", "3");
            
            try {              
                setCtx(new InitialDirContext(env));                
                ctx.close();
                return true;
            } catch (NamingException e) {
                 if (e instanceof javax.naming.CommunicationException) return false;
                 if (e instanceof javax.naming.AuthenticationException) return true; else return false;                 
            } catch (Exception e) {
                return false;
            }
            
        }
        
        public void SSLCon(String user,String pwd,String server,String dominio){
            char[] pc=null;
            char[] ps={'s','e','c','r','e','t'};
            String caCerts=kemit.util.File.nameFile("trust.ks");
                    
            this.pwd=pwd;
            env = new Hashtable();
            
            env.put(Context.INITIAL_CONTEXT_FACTORY,"com.sun.jndi.ldap.LdapCtxFactory");
            
            //TODO cambiar lo de intracentre
            env.put(Context.PROVIDER_URL, "ldap://"+server+":636/dc="+dominio);
            env.put("java.naming.ldap.factory.socket", "kemit.ssl.KemitSSLSocketFactory");
            

            env.put(Context.SECURITY_PROTOCOL, "ssl");

            env.put(Context.SECURITY_AUTHENTICATION, "simple");
            //TODO cambiar lo de intracentre
            
            env.put(Context.SECURITY_PRINCIPAL, "uid="+user+",ou=people,dc="+dominio);            
            env.put(Context.SECURITY_CREDENTIALS, pwd);
            env.put("java.naming.ldap.version", "3");

            if (debug) System.setProperty("javax.net.debug", "ssl");
            
            try {              
                KemitSSLSocketFactory.init(caCerts, "",ps, pc,"JKS", "");
                if (debug) KemitSSLSocketFactory.setDebug(true);                
                setCtx(new InitialDirContext(env));                
                setEx(null);
            } catch (Exception e) {
                setCtx(null);
                setEx(e);                
            }            
        }
        
        
        public void Con(String user,String pwd,String server,String dominio){
            env = new Hashtable();            
            env.put(Context.INITIAL_CONTEXT_FACTORY,"com.sun.jndi.ldap.LdapCtxFactory");       
            //TODO cambiar lo de intracentre
            env.put(Context.PROVIDER_URL, "ldap://"+server+":389/dc="+dominio);
            env.put("com.sun.jndi.ldap.connect.timeout", "500");
            env.put(Context.SECURITY_AUTHENTICATION, "simple");
            //TODO cambiar lo de intracentre            
            env.put(Context.SECURITY_PRINCIPAL, "uid="+user+",ou=people,dc="+dominio);            
            env.put(Context.SECURITY_CREDENTIALS, pwd);
            env.put("java.naming.ldap.version", "3");
            
            try {              
                setCtx(new InitialDirContext(env));                
                setEx(null);
            } catch (Exception e) {
                setEx(e);
                setCtx(null);
            }
            
        }
        
        
        public Session(String user,String pwd,String server,String dominio,boolean SSL)  {            
            
            if (!isServerAlive(user,pwd,server,dominio)) {
                setEx(new javax.naming.CommunicationException("NOTOY"));
                setCtx(null);
                return;
            }            
            
            if (SSL) SSLCon(user,pwd,server,dominio); else Con(user,pwd,server,dominio);
            
        }

        public DirContext getCtx() { return ctx;}
        public void setCtx(DirContext ctx) {this.ctx = ctx;}

        public Exception getEx() {return ex;}
        public void setEx(Exception ex) {this.ex = ex;}

        public Hashtable getEnv() {return env;}

        public void setEnv(Hashtable env) {this.env = env;}

        public String getPwd() {return pwd;}
        
    } 

    public class focusCambio extends FocusTraversalPolicy {

        public Component getComponentAfter(Container focusCycleRoot,Component aComponent) {
            if (aComponent.equals(txtURL)) {return txtUID;}
            else if (aComponent.equals(txtUID)) {return txtDominio;}
            else if (aComponent.equals(txtDominio)) {return txtOLDPWD;}
            else if (aComponent.equals(txtOLDPWD)) {return txtNEWPWD;}
            else if (aComponent.equals(txtNEWPWD)) {return txtRETIPE;}
            else if (aComponent.equals(txtRETIPE)) {return bCambiar;}
            else if (aComponent.equals(bCambiar)) {return bSalir;}
            else if (aComponent.equals(bSalir)) {return txtURL;}
            return txtURL;
        }

        public Component getComponentBefore(Container focusCycleRoot,Component aComponent) {
            if (aComponent.equals(txtURL)) {return bSalir;}
            else if (aComponent.equals(txtUID)) {return txtURL;}
            else if (aComponent.equals(txtDominio)) {return txtUID;}
            else if (aComponent.equals(txtOLDPWD)) {return txtDominio;}
            else if (aComponent.equals(txtNEWPWD)) {return txtOLDPWD;}
            else if (aComponent.equals(txtRETIPE)) {return txtNEWPWD;}
            else if (aComponent.equals(bCambiar)) {return txtRETIPE;}
            else if (aComponent.equals(bSalir)) {return bCambiar;}
            return txtURL;            
        }

        public Component getDefaultComponent(Container focusCycleRoot) {
            return txtURL;
        }

        public Component getLastComponent(Container focusCycleRoot) {
            return bSalir;
        }

        public Component getFirstComponent(Container focusCycleRoot) {return txtURL;}
    }
    
    
}
