/*
 * KCheckBoxJList.java
 *
 * Created on 4 de agosto de 2007, 22:14
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package kemit.component;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import kemit.ldap.objectos.GrupoLDAP;
import kemit.ldap.objectos.UsuarioLDAP;
import kemit.util.unixUtil;

/**
 *
 * @author JL
 */
public class KCheckBoxJList extends JList   {


    //TODO generalizar y beanizar
    
    static Color listForeground, listBackground,
        listSelectionForeground,
        listSelectionBackground;
    
    static {
        UIDefaults uid = UIManager.getLookAndFeel().getDefaults();
        listForeground =  uid.getColor ("List.foreground");
        listBackground =  uid.getColor ("List.background");
        listSelectionForeground =  uid.getColor ("List.selectionForeground");
        listSelectionBackground =  uid.getColor ("List.selectionBackground");
    }

    HashSet selectionCache = new HashSet();
    int toggleIndex = -1;
    boolean toggleWasSelected;
    ListSelectionModel lsm;
    
    private boolean selTodoTexto=true;
    

    public KCheckBoxJList() {
        super();
        setCellRenderer(new CheckBoxListCellRenderer());        
        lsm=this.getSelectionModel();
        addMouseListener(new CheckListener(this));
        //addKeyListener(new CheckListener(this));
    }

    public

    boolean isSelTodoTexto() {
        return selTodoTexto;
    }

    public void setSelTodoTexto(boolean selTodoTexto) {
        this.selTodoTexto = selTodoTexto;
    }
    

    class CheckBoxListCellRenderer extends DefaultListCellRenderer {
        
        JCheckBox checkbox;
        
        public CheckBoxListCellRenderer() {
            setLayout (new BorderLayout());
            checkbox = new JCheckBox();
            add(checkbox, BorderLayout.WEST);
        }

        public Component getListCellRendererComponent(JList list,Object  value,int index,boolean isSelected,boolean cellHasFocus){            
            if (value instanceof UsuarioLDAP) {
                UsuarioLDAP usu=(UsuarioLDAP) value;
                String f=usu.getDisplayName()+" {uid="+usu.getUid()+",sagaID="+usu.getSagaID()+"}";
                checkbox.setText(f);
                checkbox.setSelected (usu.isSelected());
                checkbox.setForeground (listForeground);
                checkbox.setBackground(listBackground);
                checkbox.setOpaque(true);            
            }
            if (value instanceof GrupoLDAP) {
                GrupoLDAP usu=(GrupoLDAP) value;
                String f=usu.getCn()+" {id="+usu.getGidNumber()+"}";
                checkbox.setText(f);
                checkbox.setSelected (usu.isSelected());
                checkbox.setForeground (listForeground);
                checkbox.setBackground(listBackground);
                checkbox.setOpaque(true);            
            }            
            
            return checkbox;
        }
    }
    

    
    class CheckListener implements MouseListener, KeyListener {

        KCheckBoxJList lista;
        
        public CheckListener(KCheckBoxJList lista) {this.lista = lista;}

        public void mouseClicked(MouseEvent e) { 
            if (isSelTodoTexto()) doCheck();
            else if (e.getX() < 20) doCheck();
        }

        public void mousePressed(MouseEvent e) {}

        public void mouseReleased(MouseEvent e) {}

        public void mouseEntered(MouseEvent e) {}

        public void mouseExited(MouseEvent e) {}

        public void keyPressed(KeyEvent e) { if (e.getKeyChar() == ' ') doCheck();}

        public void keyTyped(KeyEvent e) {}

        public void keyReleased(KeyEvent e) {}

        private void doCheck() {
            int index = lista.getSelectedIndex();
            if (index < 0) return;            
            Object o = lista.getModel().getElementAt(index);   
            if (o instanceof UsuarioLDAP) {
                UsuarioLDAP usu = (UsuarioLDAP) o;   
                usu.invertSelected();
            } else if (o instanceof GrupoLDAP) {
                GrupoLDAP gru=(GrupoLDAP) o;
                gru.invertSelected();
            }
            lista.repaint();    
        }

    }

    
    
}
