/*
 * AsciiUtils.java
 *
 * Created on 6 de agosto de 2007, 11:21
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package kemit.util;

/**
 *
 * @author JL
 */
public class AsciiUtils {

private static final String PLAIN_ASCII =
      "AaEeIiOoUu"    // grave
    + "AaEeIiOoUuYy"  // acute
    + "AaEeIiOoUuYy"  // circumflex
    + "AaEeIiOoUuYy"  // tilde
    + "AaEeIiOoUuYy"  // umlaut
    + "Aa"            // ring
    + "Cc"            // cedilla
    + "Nn"    
    ;

private static final String UNICODE =
 "\u00C0\u00E0\u00C8\u00E8\u00CC\u00EC\u00D2\u00F2\u00D9\u00F9"             
+"\u00C1\u00E1\u00C9\u00E9\u00CD\u00ED\u00D3\u00F3\u00DA\u00FA\u00DD\u00FD" 
+"\u00C2\u00E2\u00CA\u00EA\u00CE\u00EE\u00D4\u00F4\u00DB\u00FB\u0176\u0177" 
+"\u00C2\u00E2\u00CA\u00EA\u00CE\u00EE\u00D4\u00F4\u00DB\u00FB\u0176\u0177" 
+"\u00C4\u00E4\u00CB\u00EB\u00CF\u00EF\u00D6\u00F6\u00DC\u00FC\u0178\u00FF" 
+"\u00C5\u00E5"                                                             
+"\u00C7\u00E7"
+"\u00D1\u00F1"        
 ;
    // private constructor, can't be instanciated!
    private AsciiUtils() { }


    public static String convertNonAscii(String s) {
       StringBuffer sb = new StringBuffer();
       int n = s.length();
       for (int i = 0; i < n; i++) {
          char c = s.charAt(i);
          int pos = UNICODE.indexOf(c);
          if (pos > -1) sb.append(PLAIN_ASCII.charAt(pos)); else sb.append(c);
       }
       return sb.toString();
    }

    public static void main(String args[]) {
       String s = "resultado : \u00c8,\u00c9,\u00ca,\u00cb,\u00db,\u00d9,\u00cf,\u00ce,\u00c0,\u00c2,\u00d4,\u00e8,\u00e9,\u00ea,\u00eb,\u00fb,\u00f9,\u00ef,\u00ee,\u00e0,\u00e2,\u00f4,\u00e7,\u00d1,\u00f1,\u00c7";
       System.out.println(AsciiUtils.convertNonAscii(s));
    }
}
